Bug 1124825 - (CVE-2019-7637) VUL-0: CVE-2019-7637: SDL,SDL2: heap-based buffer overflow in SDL_FillRect in video/SDL_surface.c
(CVE-2019-7637)
VUL-0: CVE-2019-7637: SDL,SDL2: heap-based buffer overflow in SDL_FillRect in...
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P3 - Medium : Normal
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/224447/
CVSSv3:SUSE:CVE-2019-7637:5.3:(AV:L/...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2019-02-08 15:21 UTC by Robert Frohl
Modified: 2022-04-22 19:26 UTC (History)
6 users (show)

See Also:
Found By: Security Response Team
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Robert Frohl 2019-02-08 15:21:57 UTC
CVE-2019-7637

SDL (Simple DirectMedia Layer) through 1.2.15 and 2.x through 2.0.9 has a
heap-based buffer overflow in SDL_FillRect in video/SDL_surface.c.

References:
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2019-7637
https://bugzilla.libsdl.org/show_bug.cgi?id=4497
https://discourse.libsdl.org/t/vulnerabilities-found-in-libsdl-1-2-15/25720
Comment 1 Swamp Workflow Management 2019-02-20 10:20:08 UTC
This is an autogenerated message for OBS integration:
This bug (1124825) was mentioned in
https://build.opensuse.org/request/show/677641 42.3 / SDL
Comment 7 Swamp Workflow Management 2019-02-27 15:23:14 UTC
An update workflow for this issue was started.
This issue was rated as moderate.
Please submit fixed packages until 2019-03-13.
When done, reassign the bug to security-team@suse.de.
https://swamp.suse.de/webswamp/wf/64214
Comment 16 Swamp Workflow Management 2019-03-29 23:19:27 UTC
SUSE-SU-2019:13998-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    SDL-1.2.13-106.11.1
SUSE Linux Enterprise Server 11-SP4 (src):    SDL-1.2.13-106.11.1
SUSE Linux Enterprise Point of Sale 11-SP3 (src):    SDL-1.2.13-106.11.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    SDL-1.2.13-106.11.1

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 18 Swamp Workflow Management 2019-04-08 13:35:01 UTC
SUSE-SU-2019:0899-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
SUSE Linux Enterprise Software Development Kit 12-SP4 (src):    SDL-1.2.15-15.11.1
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    SDL-1.2.15-15.11.1
SUSE Linux Enterprise Server 12-SP4 (src):    SDL-1.2.15-15.11.1
SUSE Linux Enterprise Server 12-SP3 (src):    SDL-1.2.15-15.11.1
SUSE Linux Enterprise Desktop 12-SP4 (src):    SDL-1.2.15-15.11.1
SUSE Linux Enterprise Desktop 12-SP3 (src):    SDL-1.2.15-15.11.1

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 19 Swamp Workflow Management 2019-04-10 15:04:55 UTC
SUSE-SU-2019:0917-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,112
4800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-75
78,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
SUSE Linux Enterprise Module for Desktop Applications 15 (src):    SDL-1.2.15-3.9.1

*** NOTE: This information 
is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 20 Swamp Workflow Management 2019-04-15 13:11:50 UTC
SUSE-SU-2019:0950-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
SUSE Linux Enterprise Module for Desktop Applications 15 (src):    SDL2-2.0.8-3.9.1

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 21 Swamp Workflow Management 2019-04-17 19:25:16 UTC
openSUSE-SU-2019:1223-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
openSUSE Leap 15.0 (src):    SDL-1.2.15-lp150.2.3.1
Comment 22 Swamp Workflow Management 2019-04-23 19:14:20 UTC
openSUSE-SU-2019:1261-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
openSUSE Leap 15.0 (src):    SDL2-2.0.8-lp150.2.3.1
Comment 23 Maarten ter Huurne 2019-05-07 07:53:30 UTC
CVE-2019-7637.patch breaks SDL2 functionality: SDL_CreateRGBSurfaceFrom() and SDL_CreateRGBSurfaceWithFormatFrom() will always fail when this patch is applied.

The reason is the following change:

@@ -86,6 +112,10 @@ SDL_CreateRGBSurfaceWithFormat(Uint32 flags, int width, int height, int depth,
     surface->w = width;
     surface->h = height;
     surface->pitch = SDL_CalculatePitch(format, width);
+    if (!surface->pitch)
+    {
+        return NULL;
+    }
     SDL_SetClipRect(surface, NULL);
 
     if (SDL_ISPIXELFORMAT_INDEXED(surface->format->format)) {

This will cause any surface for which the computed pitch is 0 to be rejected. However, SDL_CreateRGBSurfaceFrom() and SDL_CreateRGBSurfaceWithFormatFrom() call SDL_CreateRGBSurfaceWithFormat() with a dummy width and height of 0, which causes the computed pitch to be 0 as well.

Perhaps SDL_CalculatePitch() should not use 0 as an error code, but -1 instead.
Comment 24 Swamp Workflow Management 2019-05-21 06:16:48 UTC
SUSE-SU-2019:0917-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
SUSE Linux Enterprise Module for Desktop Applications 15 (src):    SDL-1.2.15-3.9.1

*** NOTE: This information is not intended to be used for external
    communication, because this may only be a partial fix.
    If you have questions please reach out to maintenance coordination.
Comment 25 Swamp Workflow Management 2019-05-21 06:19:03 UTC
openSUSE-SU-2019:1213-1: An update that fixes 11 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1124799,1124800,1124802,1124803,1124805,1124806,1124824,1124825,1124826,1124827,1125099
CVE References: CVE-2019-7572,CVE-2019-7573,CVE-2019-7574,CVE-2019-7575,CVE-2019-7576,CVE-2019-7577,CVE-2019-7578,CVE-2019-7635,CVE-2019-7636,CVE-2019-7637,CVE-2019-7638
Sources used:
openSUSE Leap 42.3 (src):    SDL-1.2.15-20.3.1
Comment 26 Cameron Rapp 2019-05-23 05:40:34 UTC
The CVE-2019-7637.patch breaks the game devilutionX. It only shows a black window. Removing the patch corrects the problem.
Comment 27 Qiang Zheng 2019-06-03 02:58:38 UTC
Remove CVE-2019-7637.patch from SDL2, https://build.suse.de/request/show/193420
Comment 28 Swamp Workflow Management 2019-06-21 13:19:48 UTC
SUSE-SU-2019:1605-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1124825,1134135
CVE References: CVE-2019-7637
Sources used:
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15-SP1 (src):    SDL2-2.0.8-3.12.5
SUSE Linux Enterprise Module for Desktop Applications 15-SP1 (src):    SDL2-2.0.8-3.12.5
SUSE Linux Enterprise Module for Desktop Applications 15 (src):    SDL2-2.0.8-3.12.5

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 29 Swamp Workflow Management 2019-06-27 10:14:20 UTC
openSUSE-SU-2019:1633-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1124825,1134135
CVE References: CVE-2019-7637
Sources used:
openSUSE Leap 15.1 (src):    SDL2-2.0.8-lp151.4.3.1
Comment 30 Marcus Meissner 2019-06-27 10:20:32 UTC
released
Comment 31 Swamp Workflow Management 2019-06-27 10:31:01 UTC
openSUSE-SU-2019:1632-1: An update that solves one vulnerability and has one errata is now available.

Category: security (moderate)
Bug References: 1124825,1134135
CVE References: CVE-2019-7637
Sources used:
openSUSE Leap 15.0 (src):    SDL2-2.0.8-lp150.2.6.1
Comment 33 Swamp Workflow Management 2022-04-22 19:26:58 UTC
SUSE-SU-2022:14943-1: An update that fixes four vulnerabilities is now available.

Category: security (important)
Bug References: 1124825,1181201,1181202,1198001
CVE References: CVE-2019-7637,CVE-2020-14409,CVE-2020-14410,CVE-2021-33657
JIRA References: 
Sources used:
SUSE Linux Enterprise Server 11-SP4-LTSS (src):    SDL-1.2.13-106.21.1
SUSE Linux Enterprise Point of Sale 11-SP3 (src):    SDL-1.2.13-106.21.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    SDL-1.2.13-106.21.1
SUSE Linux Enterprise Debuginfo 11-SP3 (src):    SDL-1.2.13-106.21.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.